\chapter{\texttt{cryptsetup} utility}

We have chosen \texttt{cryptsetup} \cite{cryptsetup} as the program under test. \texttt{cryptsetup} is a full disk encryption (FDE) utility used on many popular Linux distributions which uses \texttt{dm-crypt} kernel module to configure the encrypted block device. \texttt{dm-crypt} module creates a virtual plaintext device that provides plaintext access to the underlying encrypted device. The mapping is transparent, and applications can use the plaintext device as normal storage. Any read from the plaintext device will cause read and decryption from the underlying encrypted device. Writing to the plaintext device causes encryption of the written data and writing ciphertext to the underlying device \cite{Broz2019thesis}. The advantage of FDE is that it operates on the lowest level of the storage stack. Therefore, encrypting the whole storage device allows using any filesystem on top of the virtual device without any changes.

The \texttt{dm-crypt} kernel module only allows directly specifying the encryption algorithm, mode, initialization vector and encryption key. The user must specify all the parameters and keys every time he tries to unlock the volume. After creating the decryption mapping, there is no check that the key was correct (apart from, e.g. checking magic values during filesystem mounting). If the user supplies a wrong decryption key, he can accidentally overwrite a part of the volume under the wrong key leading to data corruption. Changing the volume key requires re-encrypting the whole drive under the new key. Such an approach is therefore error-prone and discouraged.

LUKS (Linux Unified Key Management) was proposed and implemented by Clemens Fruhwirth \cite{LUKS_phd}. The format introduced a binary header that contains metadata about the used cipher and mode. It also introduced key encrypting keys (KEK) called keyslots. A passphrase can unlock the keyslot. To unlock the keyslot, a KEK is derived from the passphrase using a key derivation function (KDF). Multiple keyslots can be created, and they all wrap the same volume key. It is easy to add, remove or change passphrases without re-encrypting the whole disk. After introducing LUKS support in \texttt{cryptsetup}, it became widely popular and used in all major Linux distributions \cite{Broz2019thesis}.

As time went by, shortcomings of the original LUKS format became apparent. Some parameters, like the key derivation algorithm and digest size (20 bytes based on the now deprecated SHA1 function), are fixed. There is no redundant copy of the header. Therefore, damaging the header is especially dangerous. Losing the header also means losing the keyslot holding the volume key, which encrypts the sensitive data. The header is entirely stored in the first sector of the device, which is risky since many formats store magic values and metadata in it. Therefore other utilities or operating systems can accidentally overwrite the header. The original LUKS format was not designed to be extended in the future. Thus it is hard to adapt it for use cases that emerged later, like authenticated encryption or re-encryption support \cite{Broz2019thesis}.

To solve these issues, a new file format LUKS2 was proposed by Milan Brož \cite{Broz2019thesis}. To make the format future-proof, it had to be made algorithm-independent and use a generic and extensible metadata format. For this reason, JSON \cite{json} format was chosen for metadata storage in addition to the binary header. This way, developers can add new cipher support or \texttt{cryptsetup} extend the format without changing the structure of the binary header.

In LUKS2, the header is stored in two copies except for keyslots as they are intended to be removed securely and keeping multiple copies could increase the chances of a compromise. The binary header now contains a checksum of itself to detect unintentional header modification or corruption. If one of the headers is corrupted, the \texttt{cryptsetup} utility will start automatic repair based on the other header. The user can convert the older LUKS header to the LUKS2 header in place. The LUKS2 format introduced the concept of \textit{tokens} which are external applications for obtaining passphrases (e.g. using a hardware token or from a remote server) that can store additional metadata in the header \cite{Broz2019thesis}. LUKS2 metadata format became the default for newly formatted devices since \texttt{cryptsetup} version 2.1.0 \cite{cryptsetup_210_release_notes}.

Apart from LUKS and LUKS2 formats, \texttt{cryptsetup} supports mounting volumes encrypted by other disk encryption utilities. The supported options are volumes formatted by Microsoft Windows BitLocker \cite{vojta_dp, csetup_man} and VeraCrypt (or TrueCrypt) \cite{csetup_man, veracrypt, tcrypt}. For these formats, \texttt{cryptsetup} only supports reading the metadata and mounting the device. Changing the metadata (like adding or removing a passphrase) is not supported because other authors design the formats, and \texttt{cryptsetup} could introduce incompatible changes or damage the volume. In the case of BitLocker, an official format specification is not available. Therefore the support is only experimental, and any changes to the header would be hazardous.

\section{LUKS2 detailed}

We have focused the effort on fuzzing LUKS2 volumes. Therefore this format will be described in detail. The LUKS2 header starts at the beginning of the device. The first sector (512 bytes) contains the first copy of the binary header, followed by seven empty sectors (together four sectors or 4KiB). The empty sectors allow future extension and ensure atomic write of the header on disks with 4KiB sector size. Therefore the header can be written atomically on disks with both sector sizes (512 bytes and 4KiB). ASCII encoded JSON metadata follows the binary header. The size of the JSON area is variable and specified in the binary header (the \texttt{hdr\_size} field specifies the JSON area plus the binary area). Supported sizes in KiB are 12, 28, 60, 124, 252, 508, 1020, 2044 and 4092. The second copy of the binary header and JSON metadata starts right after the first JSON area's end. Therefore the possible offsets from the start of the device (in KiB) for the second binary header are 16, 32, 64, 128, 256, 512, 1024, 2048 and 4096. The second header is located at least 16KiB from the start of the device making accidental overwrite less likely. The Keyslots area begins after the second header \cite{luks2}. The layout is shown in Figure-\ref{fig:luks2hdr}.

\input{figures/luks2_hdr.tex}

The binary header structure is described in Figure-\ref{fig:luks2hdr_struct}. The header contains a magic value which is different for the primary and secondary headers (specified by the \texttt{LUKS2\_MAGIC\_1ST} and \texttt{LUKS2\_MAGIC\_2ND} constants). Next is the \texttt{version} field, which is always 2 for LUKS2. The \texttt{hdr\_size} specifies the size of the JSON area plus 4KiB for the binary header. The size must be the same for both primary and secondary headers. The \texttt{seqid} field is used for header versioning. It is increased after every header update, and during header repair, a newer header (i.e. with higher \texttt{seqid} is automatically chosen. The \texttt{label} and \texttt{subsystem} fields can contain arbitrary, at most 48 character long, user-specified description of the volume. The \texttt{csum\_alg} field contains a string name of the checksum algorithm used for accidental header damage detection (SHA-256 is used by default). The whole binary header and JSON area are processed by the algorithm specified by \texttt{csum\_alg}, and the result is stored in \texttt{csum} field. During the checksum calculation, the \texttt{csum} field is set to zeroes. The \texttt{salt} field contains completely random data for every header copy. It is generated during formatting and regenerated only after header repair. A universally unique identifier (UUID) \cite{uuid} is specified in the \texttt{uuid} field. Finally, the \texttt{hdr\_offset} specifies the exact offset of the header on the physical device \cite{luks2}.

\input{figures/luks2_hdr_struct.tex}

The binary header is followed by the JSON area. The whole binary header and JSON area are repeated twice (there is a secondary copy of the binary header and JSON area). A keyslots area follows the secondary header. It is used for storing binary cryptographic material associated with the keyslots. The binary structures stored in the keyslots area depend on the specific keyslot type that references them \cite{luks2}.


 The JSON area contains a top-level JSON object with five mandatory objects: \textbf{config}, \textbf{keyslots}, \textbf{digests}, \textbf{segments} and \textbf{tokens}. Every object, except for config, contains sub-objects referenced by an integer converted to string. JSON format does not support 64 bit integers, so they are converted to string. Their relationship is illustrated on Figure-\ref{fig:luks2schema}.

\input{figures/luks2_objects.tex}

The \textbf{config} object contains properties that apply to the whole encrypted device. The properties include the size of the JSON area (must correspond to the \texttt{hdr\_size} from the binary header), size of the keyslots area, flags and requirements. Flags array specifies various \texttt{dm-crypt} options for activating the device like allowing discards or integrity journal. Requirements array specifies which features must the \texttt{cryptsetup} utility implement. If the used version of the implementation does not support any of the specified requirements, it must not modify or activate the volume \cite{luks2}.

The \textbf{keyslots} object describes how and where is the volume key encrypted. Every keyslot object contains the type, key size of the wrapped key, priority and area object. The area object describes the encrypted blob located in the keyslots area. It specifies the blob's location and size, the algorithm used for key wrapping, and the key's size after its decryption. The \textit{luks2} keyslot type also describes the used KDF, its parameters and the anti-forensic splitter. It allows using different KDFs for every keyslot (as seen in Listing-\ref{lst:json_header}) and easily adding support for new KDFs in the future \cite{luks2}.

The \textbf{segments} object describes encrypted user data segments in the data area (from the end of the keyslots section to the end of the volume). It specifies the offset from the start of the device and the size of the segment. The segment type can be \textit{linear} or \textit{crypt}. Linear means unencrypted and is used only during re-encryption. \textit{Crypt} type specifies the segment encryption algorithm, sector size, optional integrity protection parameters and additional flags.

The \textbf{digests} object is used for verifying that the wrapped key (stored in keyslot) was correctly decrypted. It specifies the type of the digest, the associated keyslots and segments, the salt used for digest calculation and the calculated digest. The \textit{pbkdf2} digest-type specifies also the KDF parameters. Every keyslot must have an associated digest so that it can be verified. If no segment is associated with the digest, the keyslot is called \textit{unbound} \cite{luks2}. This way, arbitrary key material can be stored in the LUKS2 header (e.g. by a token that uses the wrapped key to authenticate against a server and obtain a passphrase from it).

Finally, the \textbf{tokens} object contains metadata used by \texttt{cryptsetup} utility, \texttt{cryptsetup} plugin or other application for obtaining a passphrase (e.g. from a smartcard or remote server). The only mandatory fields are type and the associated keyslots, for which the token can obtain the unlocking passphrase. The token implementation can add additional custom fields. The \texttt{cryptsetup} utility has built-in support only for \textit{luks2-keyring} token type. An example JSON metadata produced by \texttt{cryptsetup 2.4.3} with an external \texttt{systemd-tpm2} \cite{cryptenroll} token plugin is shown in Listing-\ref{lst:json_header}.

\input{figures/luks2_json.tex}

%% \input{figures/luks2_json.tex}
%% 
%% \begin{itemize}
%%     \item current test suite
%% \end{itemize}
%% 
%% \section{Supported ecryption metadata formats}
%% 
%% \begin{itemize}
%%     \item LUKS/LUKS2
%%     \item Bitlocker
%%     \item VeraCrypt
%% \end{itemize}
%% 
%% \section{LUKS2 detailed}
